Index: code/branches/core/src/orxonox/core/CMakeLists.txt
===================================================================
--- code/branches/core/src/orxonox/core/CMakeLists.txt	(revision 791)
+++ code/branches/core/src/orxonox/core/CMakeLists.txt	(revision 792)
@@ -13,4 +13,5 @@
   OutputHandler.cc
   Language.cc
+  Loader.cc
 )
 
Index: code/branches/core/src/orxonox/core/ConfigValueContainer.cc
===================================================================
--- code/branches/core/src/orxonox/core/ConfigValueContainer.cc	(revision 791)
+++ code/branches/core/src/orxonox/core/ConfigValueContainer.cc	(revision 792)
@@ -28,7 +28,7 @@
 #include <fstream>
 
+#include "ConfigValueContainer.h"
 #include "util/Tokenizer.h"
 #include "util/Convert.h"
-#include "ConfigValueContainer.h"
 
 #define CONFIGFILEPATH "orxonox.ini"
@@ -43,298 +43,129 @@
         @param defvalue The default-value
     */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, int defvalue)
+    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, MultiTypeMath defvalue)
     {
         this->bAddedDescription_ = false;
         this->classname_ = classname;
         this->varname_ = varname;
-        this->type_ = VT_Int;
-
-        ConvertValue(&this->defvalueString_, defvalue, std::string("0"));           // Try to convert the default-value to a string
+
+        this->valueToString(&this->defvalueString_, defvalue);                      // Try to convert the default-value to a string
         this->searchConfigFileLine();                                               // Search the entry in the config-file
 
         std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
+        if (!this->parseString(valueString, defvalue))                              // Try to convert the string to a value
             this->resetConfigFileEntry();                                           // The conversion failed
     }
 
     /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, unsigned int defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_uInt;
-
-        ConvertValue(&this->defvalueString_, defvalue, std::string("0"));           // Try to convert the default-value to a string
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, char defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_Char;
-
-        ConvertValue(&this->defvalueString_, (int)defvalue, std::string("0"));      // Try to convert the default-value to a string
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, unsigned char defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_uChar;
-
-        ConvertValue(&this->defvalueString_, (unsigned int)defvalue, std::string("0"));     // Try to convert the default-value to a string
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, float defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_Float;
-
-        ConvertValue(&this->defvalueString_, defvalue, std::string("0.000000"));    // Try to convert the default-value to a string
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, double defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_Double;
-
-        ConvertValue(&this->defvalueString_, defvalue, std::string("0.000000"));    // Try to convert the default-value to a string
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, long double defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_LongDouble;
-
-        ConvertValue(&this->defvalueString_, defvalue, std::string("0.000000"));    // Try to convert the default-value to a string
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, bool defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_Bool;
-
-        // Convert the default-value from bool to string
-        if (defvalue)
-            this->defvalueString_ = "true";
-        else
-            this->defvalueString_ = "false";
-
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, const std::string& defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_String;
-
-        this->defvalueString_ = "\"" + defvalue + "\"";                             // Convert the string to a "config-file-string" with quotes
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-        std::string valueString = this->parseValueString(false);                    // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, const char* defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_ConstChar;
-
-        this->defvalueString_ = "\"" + std::string(defvalue) + "\"";                // Convert the string to a "config-file-string" with quotes
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-        std::string valueString = this->parseValueString(false);                    // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, Vector2 defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_Vector2;
-
-        // Try to convert the default-value from Vector2 to string
-        std::ostringstream ostream;
-        if (ostream << "(" << defvalue.x << "," << defvalue.y << ")")
-            this->defvalueString_ = ostream.str();
-        else
-            this->defvalueString_ = "(0,0)";
-
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, Vector3 defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_Vector3;
-
-        // Try to convert the default-value from Vector3 to string
-        std::ostringstream ostream;
-        if (ostream << "(" << defvalue.x << "," << defvalue.y << "," << defvalue.z << ")")
-            this->defvalueString_ = ostream.str();
-        else
-            this->defvalueString_ = "(0,0,0)";
-
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
-    }
-
-    /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param value This is only needed to determine the right type.
-        @param classname The name of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(const std::string& classname, const std::string& varname, ColourValue defvalue)
-    {
-        this->bAddedDescription_ = false;
-        this->classname_ = classname;
-        this->varname_ = varname;
-        this->type_ = VT_ColourValue;
-
-        // Try to convert the default-value from ColourValue to string
-        std::ostringstream ostream;
-        if (ostream << "(" << defvalue.r << "," << defvalue.g << "," << defvalue.b << "," << defvalue.a << ")")
-            this->defvalueString_ = ostream.str();
-        else
-            this->defvalueString_ = "(0,0,0,0)";
-
-        this->searchConfigFileLine();                                               // Search the entry in the config-file
-        std::string valueString = this->parseValueString();                         // Parses the value string from the config-file-entry
-        if (!this->parseSting(valueString, defvalue))                               // Try to convert the string to a value
-            this->resetConfigFileEntry();                                           // The conversion failed
+        @brief Converts a value to a string.
+        @param output The string to write to
+        @param input The value to convert
+        @return True if the converson was successful
+    */
+    bool ConfigValueContainer::valueToString(std::string* output, MultiTypeMath& input)
+    {
+        if (this->value_.getType() == MT_int)
+            return ConvertValue(output, input.getInt(), std::string("0"));
+        else if (this->value_.getType() == MT_uint)
+            return ConvertValue(output, input.getUnsignedInt(), std::string("0"));
+        else if (this->value_.getType() == MT_char)
+            return ConvertValue(output, input.getChar(), std::string("0"));
+        else if (this->value_.getType() == MT_uchar)
+            return ConvertValue(output, input.getUnsignedChar(), std::string("0"));
+        else if (this->value_.getType() == MT_short)
+            return ConvertValue(output, input.getShort(), std::string("0"));
+        else if (this->value_.getType() == MT_ushort)
+            return ConvertValue(output, input.getUnsignedShort(), std::string("0"));
+        else if (this->value_.getType() == MT_long)
+            return ConvertValue(output, input.getLong(), std::string("0"));
+        else if (this->value_.getType() == MT_ulong)
+            return ConvertValue(output, input.getUnsignedLong(), std::string("0"));
+        else if (this->value_.getType() == MT_float)
+            return ConvertValue(output, input.getFloat(), std::string("0.000000"));
+        else if (this->value_.getType() == MT_double)
+            return ConvertValue(output, input.getDouble(), std::string("0.000000"));
+        else if (this->value_.getType() == MT_longdouble)
+            return ConvertValue(output, input.getChar(), std::string("0.000000"));
+        else if (this->value_.getType() == MT_bool)
+        {
+            if (input.getBool())
+                (*output) = "true";
+            else
+                (*output) = "false";
+
+            return true;
+        }
+        else if (this->value_.getType() == MT_constchar)
+        {
+            (*output) = "\"" + input.getString() + "\"";
+            return true;
+        }
+        else if (this->value_.getType() == MT_string)
+        {
+            (*output) = "\"" + input.getString() + "\"";
+            return true;
+        }
+        else if (this->value_.getType() == MT_vector2)
+        {
+            std::ostringstream ostream;
+            if (ostream << "(" << input.getVector2().x << "," << input.getVector2().y << ")")
+            {
+                (*output) = ostream.str();
+                return true;
+            }
+            else
+            {
+                (*output) = "(0,0)";
+                return false;
+            }
+        }
+        else if (this->value_.getType() == MT_vector3)
+        {
+            std::ostringstream ostream;
+            if (ostream << "(" << input.getVector3().x << "," << input.getVector3().y << "," << input.getVector3().z << ")")
+            {
+                (*output) = ostream.str();
+                return true;
+            }
+            else
+            {
+                (*output) = "(0,0,0)";
+                return false;
+            }
+        }
+        else if (this->value_.getType() == MT_colourvalue)
+        {
+            std::ostringstream ostream;
+            if (ostream << "(" << input.getColourValue().r << "," << input.getColourValue().g << "," << input.getColourValue().b << "," << input.getColourValue().a << ")")
+            {
+                (*output) = ostream.str();
+                return true;
+            }
+            else
+            {
+                (*output) = "(0,0,0,0)";
+                return false;
+            }
+        }
+        else if (this->value_.getType() == MT_quaternion)
+        {
+            std::ostringstream ostream;
+            if (ostream << "(" << input.getQuaternion().w << "," << input.getQuaternion().x << "," << input.getQuaternion().y << "," << input.getQuaternion().z << ")")
+            {
+                (*output) = ostream.str();
+                return true;
+            }
+            else
+            {
+                (*output) = "(0,0,0,0)";
+                return false;
+            }
+        }
+        else if (this->value_.getType() == MT_radian)
+            return ConvertValue(output, input.getRadian(), std::string("0.000000"));
+        else if (this->value_.getType() == MT_degree)
+            return ConvertValue(output, input.getDegree(), std::string("0.000000"));
+
+        return false;
     }
 
@@ -344,32 +175,46 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input)
-    {
-        if (this->type_ == ConfigValueContainer::VT_Int)
-            return this->parseSting(input, this->value_.value_int_);
-        else if (this->type_ == ConfigValueContainer::VT_uInt)
-            return this->parseSting(input, this->value_.value_uint_);
-        else if (this->type_ == ConfigValueContainer::VT_Char)
-            return this->parseSting(input, this->value_.value_char_);
-        else if (this->type_ == ConfigValueContainer::VT_uChar)
-            return this->parseSting(input, this->value_.value_uchar_);
-        else if (this->type_ == ConfigValueContainer::VT_Float)
-            return this->parseSting(input, this->value_.value_float_);
-        else if (this->type_ == ConfigValueContainer::VT_Double)
-            return this->parseSting(input, this->value_.value_double_);
-        else if (this->type_ == ConfigValueContainer::VT_LongDouble)
-            return this->parseSting(input, this->value_.value_long_double_);
-        else if (this->type_ == ConfigValueContainer::VT_Bool)
-            return this->parseSting(input, this->value_.value_bool_);
-        else if (this->type_ == ConfigValueContainer::VT_String)
-            return this->parseSting(input, this->value_string_);
-        else if (this->type_ == ConfigValueContainer::VT_ConstChar)
-            return this->parseSting(input, this->value_string_);
-        else if (this->type_ == ConfigValueContainer::VT_Vector2)
-            return this->parseSting(input, this->value_vector2_);
-        else if (this->type_ == ConfigValueContainer::VT_Vector3)
-            return this->parseSting(input, this->value_vector3_);
-        else if (this->type_ == ConfigValueContainer::VT_ColourValue)
-            return this->parseSting(input, this->value_colourvalue_);
+    bool ConfigValueContainer::parseString(const std::string& input, MultiTypeMath& defvalue)
+    {
+        if (this->value_.getType() == MT_int)
+            return this->parseString(input, defvalue.getInt());
+        else if (this->value_.getType() == MT_uint)
+            return this->parseString(input, defvalue.getUnsignedInt());
+        else if (this->value_.getType() == MT_char)
+            return this->parseString(input, defvalue.getChar());
+        else if (this->value_.getType() == MT_uchar)
+            return this->parseString(input, defvalue.getUnsignedChar());
+        else if (this->value_.getType() == MT_short)
+            return this->parseString(input, defvalue.getShort());
+        else if (this->value_.getType() == MT_ushort)
+            return this->parseString(input, defvalue.getUnsignedShort());
+        else if (this->value_.getType() == MT_long)
+            return this->parseString(input, defvalue.getLong());
+        else if (this->value_.getType() == MT_ulong)
+            return this->parseString(input, defvalue.getUnsignedLong());
+        else if (this->value_.getType() == MT_float)
+            return this->parseString(input, defvalue.getFloat());
+        else if (this->value_.getType() == MT_double)
+            return this->parseString(input, defvalue.getDouble());
+        else if (this->value_.getType() == MT_longdouble)
+            return this->parseString(input, defvalue.getLongDouble());
+        else if (this->value_.getType() == MT_bool)
+            return this->parseString(input, defvalue.getBool());
+        else if (this->value_.getType() == MT_constchar)
+            return this->parseString(input, defvalue.getString());
+        else if (this->value_.getType() == MT_string)
+            return this->parseString(input, defvalue.getString());
+        else if (this->value_.getType() == MT_vector2)
+            return this->parseString(input, defvalue.getVector2());
+        else if (this->value_.getType() == MT_vector3)
+            return this->parseString(input, defvalue.getVector3());
+        else if (this->value_.getType() == MT_colourvalue)
+            return this->parseString(input, defvalue.getColourValue());
+        else if (this->value_.getType() == MT_quaternion)
+            return this->parseString(input, defvalue.getQuaternion());
+        else if (this->value_.getType() == MT_radian)
+            return this->parseString(input, defvalue.getRadian());
+        else if (this->value_.getType() == MT_degree)
+            return this->parseString(input, defvalue.getDegree());
 
         return false;
@@ -382,7 +227,10 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, int defvalue)
-    {
-        return ConvertValue(&this->value_.value_int_, input, defvalue);
+    bool ConfigValueContainer::parseString(const std::string& input, int defvalue)
+    {
+        int temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        ((MultiTypePrimitive)this->value_).setValue(temp);
+        return success;
     }
 
@@ -393,7 +241,10 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, unsigned int defvalue)
-    {
-        return ConvertValue(&this->value_.value_uint_, input, defvalue);
+    bool ConfigValueContainer::parseString(const std::string& input, unsigned int defvalue)
+    {
+        unsigned int temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        ((MultiTypePrimitive)this->value_).setValue(temp);
+        return success;
     }
 
@@ -404,8 +255,11 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, char defvalue)
+    bool ConfigValueContainer::parseString(const std::string& input, char defvalue)
     {
         // I used value_int_ instead of value_char_ to avoid number <-> char confusion in the config-file
-        return ConvertValue(&this->value_.value_int_, input, (int)defvalue);
+        int temp;
+        bool success = ConvertValue(&temp, input, (int)defvalue);
+        ((MultiTypePrimitive)this->value_).setValue((char)temp);
+        return success;
     }
 
